package repository

import (
	"strings"
	"time"

	"be.ems/src/framework/datasource"
	"be.ems/src/framework/logger"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/framework/utils/repo"
	"be.ems/src/modules/network_element/model"
)

// 实例化数据层 NeConfig 结构体
var NewNeConfig = &NeConfig{
	selectSql: `select id, ne_type, param_name, param_display, param_type, param_json, param_sort, param_perms, update_time from ne_config`,

	resultMap: map[string]string{
		"id":            "ID",
		"ne_type":       "NeType",
		"param_name":    "ParamName",
		"param_display": "ParamDisplay",
		"param_type":    "ParamType",
		"param_json":    "ParamJson",
		"param_sort":    "ParamSort",
		"param_perms":   "ParamPerms",
		"update_time":   "UpdateTime",
	},
}

// NeConfig 网元参数配置可用属性值 数据层处理
type NeConfig struct {
	// 查询视图对象SQL
	selectSql string
	// 结果字段与实体映射
	resultMap map[string]string
}

// convertResultRows 将结果记录转实体结果组
func (r *NeConfig) convertResultRows(rows []map[string]any) []model.NeConfig {
	arr := make([]model.NeConfig, 0)
	for _, row := range rows {
		item := model.NeConfig{}
		for key, value := range row {
			if keyMapper, ok := r.resultMap[key]; ok {
				repo.SetFieldValue(&item, keyMapper, value)
			}
		}
		arr = append(arr, item)
	}
	return arr
}

// SelectPage 根据条件分页查询字典类型
func (r *NeConfig) SelectPage(query map[string]any) map[string]any {
	// 查询条件拼接
	var conditions []string
	var params []any
	if v, ok := query["neType"]; ok && v != "" {
		conditions = append(conditions, "ne_type = ?")
		params = append(params, v)
	}
	if v, ok := query["paramName"]; ok && v != "" {
		conditions = append(conditions, "param_name = ?")
		params = append(params, v)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	result := map[string]any{
		"total": 0,
		"rows":  []model.NeHost{},
	}

	// 查询数量 长度为0直接返回
	totalSql := "select count(id) as 'total' from ne_config"
	totalRows, err := datasource.RawDB("", totalSql+whereSql, params)
	if err != nil {
		logger.Errorf("total err => %v", err)
		return result
	}
	total := parse.Number(totalRows[0]["total"])
	if total == 0 {
		return result
	} else {
		result["total"] = total
	}

	// 分页
	pageNum, pageSize := repo.PageNumSize(query["pageNum"], query["pageSize"])
	pageSql := " limit ?,? "
	params = append(params, pageNum*pageSize)
	params = append(params, pageSize)

	// 查询数据
	querySql := r.selectSql + whereSql + pageSql
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return result
	}

	// 转换实体
	result["rows"] = r.convertResultRows(results)
	return result
}

// SelectList 根据实体查询
func (r *NeConfig) SelectList(param model.NeConfig) []model.NeConfig {
	// 查询条件拼接
	var conditions []string
	var params []any
	if param.NeType != "" {
		conditions = append(conditions, "ne_type = ?")
		params = append(params, param.NeType)
	}
	if param.ParamName != "" {
		conditions = append(conditions, "param_name = ?")
		params = append(params, param.ParamName)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	// 查询数据
	querySql := r.selectSql + whereSql + " order by param_sort asc "
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	return r.convertResultRows(results)
}

// SelectByIds 通过ID查询
func (r *NeConfig) SelectByIds(ids []string) []model.NeConfig {
	placeholder := repo.KeyPlaceholderByQuery(len(ids))
	querySql := r.selectSql + " where id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(ids)
	results, err := datasource.RawDB("", querySql, parameters)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return []model.NeConfig{}
	}
	// 转换实体
	return r.convertResultRows(results)
}

// Insert 新增信息
func (r *NeConfig) Insert(param model.NeConfig) string {
	// 参数拼接
	params := make(map[string]any)
	if param.NeType != "" {
		params["ne_type"] = param.NeType
	}
	if param.ParamName != "" {
		params["param_name"] = param.ParamName
	}
	if param.ParamDisplay != "" {
		params["param_display"] = param.ParamDisplay
	}
	if param.ParamType != "" {
		params["param_type"] = param.ParamType
	}
	if param.ParamJson != "" {
		params["param_json"] = param.ParamJson
	}
	params["param_sort"] = param.ParamSort
	if param.ParamPerms != "" {
		params["param_perms"] = param.ParamPerms
	}
	params["update_time"] = time.Now().UnixMilli()

	// 构建执行语句
	keys, placeholder, values := repo.KeyPlaceholderValueByInsert(params)
	sql := "insert into ne_config (" + strings.Join(keys, ",") + ")values(" + placeholder + ")"

	db := datasource.DefaultDB()
	// 开启事务
	tx := db.Begin()
	// 执行插入
	err := tx.Exec(sql, values...).Error
	if err != nil {
		logger.Errorf("insert row : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 获取生成的自增 ID
	var insertedID string
	err = tx.Raw("select last_insert_id()").Row().Scan(&insertedID)
	if err != nil {
		logger.Errorf("insert last id : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 提交事务
	tx.Commit()
	return insertedID
}

// Update 修改信息
func (r *NeConfig) Update(param model.NeConfig) int64 {
	// 参数拼接
	params := make(map[string]any)
	if param.NeType != "" {
		params["ne_type"] = param.NeType
	}
	if param.ParamName != "" {
		params["param_name"] = param.ParamName
	}
	if param.ParamDisplay != "" {
		params["param_display"] = param.ParamDisplay
	}
	if param.ParamType != "" {
		params["param_type"] = param.ParamType
	}
	if param.ParamJson != "" {
		params["param_json"] = param.ParamJson
	}
	params["param_sort"] = param.ParamSort
	if param.ParamPerms != "" {
		params["param_perms"] = param.ParamPerms
	}
	params["update_time"] = time.Now().UnixMilli()

	// 构建执行语句
	keys, values := repo.KeyValueByUpdate(params)
	sql := "update ne_config set " + strings.Join(keys, ",") + " where id = ?"

	// 执行更新
	values = append(values, param.ID)
	rows, err := datasource.ExecDB("", sql, values)
	if err != nil {
		logger.Errorf("update row : %v", err.Error())
		return 0
	}
	return rows
}

// DeleteByIds 批量删除信息
func (r *NeConfig) DeleteByIds(ids []string) int64 {
	placeholder := repo.KeyPlaceholderByQuery(len(ids))
	sql := "delete from ne_config where id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(ids)
	results, err := datasource.ExecDB("", sql, parameters)
	if err != nil {
		logger.Errorf("delete err => %v", err)
		return 0
	}
	return results
}
